// *************************************************************
//   Created with BCX -- The BASIC To C Translator (ver 5.06.183)
//  BCX (c) 1999, 2000, 2001, 2002, 2003, 2004, 2005 by Kevin Diggins
// *************************************************************
//     Translated for compiling with a C Compiler
// *************************************************************
#include <conio.h>
#include <direct.h>
#include <ctype.h>
#include <io.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <time.h>
#include <stdarg.h>
#include <process.h>


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
  #define overloaded
  #define C_EXPORT EXTERN_C __declspec(dllexport)
  #define C_IMPORT EXTERN_C __declspec(dllimport)
#else
  #define C_EXPORT __declspec(dllexport)
  #define C_IMPORT __declspec(dllimport)
#endif

// Open Watcom defs
#if defined( __WATCOM_CPLUSPLUS__ )
  #define atanl atan
  #define sinl  sin
  #define cosl  cos
  #define tanl  tan
  #define asinl asin
  #define acosl acos
  #define log10l log10
  #define logl   log
  #define _fcloseall fcloseall
#endif

// Borland C++ 5.5.1 defs - bcc32.exe
#if defined( __BCPLUSPLUS__ )
  // ===== Borland Libraries ==========
  #pragma comment(lib,"import32.lib")
  #pragma comment(lib,"cw32.lib")
  // ==================================
#endif

// Microsoft VC++
#ifndef DECLSPEC_UUID
  #if (_MSC_VER >= 1100) && defined ( __cplusplus )
    #define DECLSPEC_UUID(x)    __declspec(uuid(x))
  #else
    #define DECLSPEC_UUID(x)
  #endif
#endif


#if !defined( __LCC__ )
// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
#else
#pragma lib <winspool.lib>
#pragma lib <shell32.lib>
#pragma lib <ole32.lib>
#pragma lib <oleaut32.lib>
#pragma lib <uuid.lib>
#pragma lib <odbc32.lib>
#pragma lib <odbccp32.lib>
#pragma lib <winmm.lib>
#pragma lib <imagehlp.lib>
#pragma lib <version.lib>
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************
#endif
// *************************************************
//                System Variables
// *************************************************


// *************************************************
//            User Global Variables
// *************************************************

static char    filename[2048];
static int     dummyval1;
static int     dummyval2;
static int     dummyval3;
static int     dummyval4;
static int     neirobangou;
static char    RetStr1[2048];
static char    RetStr2[2048];
static char    RetStr3[2048];
static char    RetStr4[2048];
static unsigned char   defnotelength;
static unsigned char   notenum;
static unsigned char   octnum;
static unsigned char   octmult;
static char    Buffer[2048];
static char    Buffer2[2048];
static int     RetVal;
static FILE*  hMML_File;
static FILE*  hNewMMD;
static unsigned char   timerbsetting;
static unsigned char   timerbsetting2;
static char    newfilename[2048];
static char    songtitle[2048];
static char    filext[2048];
static char    filename2[2048];
static int     mmlfilepos;
static unsigned short  mmlstringpos;
static int     userneiropos;
static int     filepos;
static int     keepgoing;
static int     keepgoing2;
static int     PartAStart;
static int     PartBStart;
static int     PartCStart;
static int     PartDStart;
static int     PartEStart;
static int     PartFStart;
static int     PartGStart;
static int     PartHStart;
static int     PartIStart;
static int     PartJStart;
static int     PartAFilepos;
static int     PartBFilepos;
static int     PartCFilepos;
static int     PartDFilepos;
static int     PartEFilepos;
static int     PartFFilepos;
static int     PartGFilepos;
static int     PartHFilepos;
static int     PartIFilepos;
static int     PartJFilepos;
static unsigned char   notelength;
static int     currentchannel;
static unsigned char   pitchbend;
static int     stopsub;



// *************************************************
//               Standard Macros
// *************************************************

#define Clear(arg)memset(&arg,0,sizeof(arg))
#define PUT(A,B,C)fwrite(B,1,C,A)
#define VAL(a)(double)atof(a)


// *************************************************
//               Standard Prototypes
// *************************************************

int     str_cmp(char*, char*);
int     EoF (FILE*);
char*   BCX_TmpStr(size_t);
char*   mid (char*, int, int);
char*   ltrim (char*,char);
char*   rtrim (char*,char);
char*   right (char*,int);
char*   join (int, ... );
char*   MKI (int);

// *************************************************
//               User Prototypes
// *************************************************

void    endtrack (void);
void    InterpretMML (void);
void    selmmlevent (void);
void    writestartpos (void);
void    WriteNote (void);
void    AdvanceFilePos (int);
void    GetThreeDigits (void);
void    GetThreeDigits2 (void);
void    GetTwoDigits (void);

// *************************************************
//                  Main Program
// *************************************************

int main(int argc, char *argv[])
{
strcpy(filename,ltrim(argv[1],32));
strcpy(filename2,filename);
strcpy(filext,right(filename2,4));
strcpy(newfilename,join(2,filename,".mmd"));
if(str_cmp(filext,".mml")!=0)
  {
    strcpy(filename2,join(2,filename2,".mml"));
  }
if(filename[0]==0)
  {
    printf("%s\n","No input file");
	exit(0);
  }
defnotelength=24;
notelength=defnotelength;
octnum=4;
octmult=octnum*12;
if((hMML_File=fopen(filename2,"r"))==0)
 {
fprintf(stderr,"Can't open file %s\n",filename2);exit(1);
 }
if((hNewMMD=fopen(newfilename,"wb+"))==0)
 {
fprintf(stderr,"Can't open file %s\n",newfilename);exit(1);
 }
songtitle[0]=0;
fgets(songtitle,1048576,hMML_File);
if(songtitle[strlen(songtitle)-1]==10)songtitle[strlen(songtitle)-1]=0;
RetVal=strlen(songtitle);
filepos=24;
fseek(hNewMMD,filepos,0);
fprintf(hNewMMD,"%s",songtitle);
filepos+=RetVal;
filepos++;
Clear (Buffer);
Buffer[0]=0;
fgets(Buffer,1048576,hMML_File);
if(Buffer[strlen(Buffer)-1]==10)Buffer[strlen(Buffer)-1]=0;
timerbsetting=VAL(Buffer);
Clear (Buffer);
strcpy(Buffer,MKI(timerbsetting));
Clear (Buffer2);
strcpy(Buffer2,rtrim(Buffer,32));
Clear (Buffer);
if(timerbsetting==32)
  {
    strcpy(Buffer2," ");
  }
fseek(hNewMMD,21,0);
PUT(hNewMMD,Buffer2,1);
fseek(hNewMMD,filepos,0);
PartAStart=filepos;
PartAFilepos=filepos;
currentchannel=0;
keepgoing=1;
keepgoing2=1;
while(keepgoing2==1)
  {
    keepgoing=1;
    InterpretMML();
    currentchannel++;
fseek(hMML_File,0,0);
    Buffer[0]=0;
    fgets(Buffer,1048576,hMML_File);
    if(Buffer[strlen(Buffer)-1]==10)Buffer[strlen(Buffer)-1]=0;
    Buffer[0]=0;
    fgets(Buffer,1048576,hMML_File);
    if(Buffer[strlen(Buffer)-1]==10)Buffer[strlen(Buffer)-1]=0;
    if(currentchannel==10)
      {
        keepgoing2=0;
      }
  }
writestartpos();
if(hNewMMD)
 {
   fclose(hNewMMD);
   hNewMMD=NULL;
 }
if(hMML_File)
 {
   fclose(hMML_File);
   hMML_File=NULL;
 }

LEAVEITALL:;
fflush(stdout);
//ExitProcess(0);
	//exit(0);
  return 0;   //  End of main program
}

// *************************************************
//                 Runtime Functions
// *************************************************

char *BCX_TmpStr (size_t Bites)
{
  static int   StrCnt;
  static char *StrFunc[2048];
  StrCnt=(StrCnt + 1) & 2047;
  if(StrFunc[StrCnt]) free (StrFunc[StrCnt]);
  return StrFunc[StrCnt]=(char*)calloc(Bites+128,sizeof(char));
}


int str_cmp (char *a, char *b)
{
  register int counter=0;
  while(1)
   {
    if((a[counter]^b[counter]))
     {
      if((unsigned int) a[counter]>= (unsigned int) b[counter])
      return  1;
      return -1;
     }
    if(!a[counter]) return 0;
    counter++;
   }
#if !defined( __cplusplus )
 return 0;
#endif
}


int EoF (FILE* stream)
{
  register int c, status = ((c = fgetc(stream)) == EOF);
  ungetc(c,stream);
  return status;
}


char *right (char *S, int length)
{
  int tmplen = strlen(S);
  char *BCX_RetStr = BCX_TmpStr(tmplen);
  tmplen -= length;
  if (tmplen<0) tmplen = 0;
  return strcpy(BCX_RetStr, S + tmplen);
}


char *mid (char *S, int start, int length)
{
  register int tmplen = strlen(S);
  char *strtmp;
  if(start>tmplen||start<1) return BCX_TmpStr(1);
  if (length < 0) length = tmplen - start + 1;
  strtmp = BCX_TmpStr(length);
  strncpy(strtmp,&S[start-1],length);
  strtmp[length] = 0;
  return strtmp;
}


char *ltrim (char *S, char c)
{
  if(S[0]==0) return S;
  register char *strtmp = BCX_TmpStr(strlen(S));
  strcpy(strtmp,S);
  while((*strtmp==32 || *strtmp==c) && *strtmp !=0) strtmp++;
  return strtmp;
}


char *rtrim (char *S,char c)
{
  if(S[0]==0) return S;
  register int i = strlen(S);
  register char *strtmp = BCX_TmpStr(i);
  strcpy(strtmp,S);
  while(i--)
    {
      if(strtmp[i]==c)  strtmp[i]=32;
      if(strtmp[i]!=32) break;
    }
  strtmp[++i]=0;
  return strtmp;
}


char * join(int n, ...)
{
  register int i = n, tmplen = 0;
  register char *s_;
  register char *strtmp;
  va_list marker;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    tmplen += strlen(s_);
  }
  strtmp = BCX_TmpStr(tmplen);
  va_end(marker); // Reset variable arguments
  i = n;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    strcat(strtmp, s_);
  }
  va_end(marker); // Reset variable arguments
  return strtmp;
}


char *MKI (int cvt)
{
  static char temp[3];
  return (char *)memmove(temp,&cvt,2);
}



// ************************************
//       User Subs and Functions
// ************************************


void endtrack (void)
{
  while(1)
  {
    if(currentchannel==0)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartBStart=filepos;
        break;
      }
    if(currentchannel==1)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartCStart=filepos;
        break;
      }
    if(currentchannel==2)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartDStart=filepos;
        break;
      }
    if(currentchannel==3)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartEStart=filepos;
        break;
      }
    if(currentchannel==4)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartFStart=filepos;
        break;
      }
    if(currentchannel==5)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartGStart=filepos;
        break;
      }
    if(currentchannel==6)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartHStart=filepos;
        break;
      }
    if(currentchannel==7)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartIStart=filepos;
        break;
      }
    if(currentchannel==8)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        PartJStart=filepos;
        break;
      }
    if(currentchannel==9)
      {
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(254),32));
        PUT(hNewMMD,Buffer2,1);
        AdvanceFilePos(2);
        userneiropos=filepos;
fseek(hNewMMD,userneiropos,0);
        Clear (Buffer2);
        strcpy(Buffer2,rtrim(MKI(0),32));
        PUT(hNewMMD,Buffer2,1);
      }
    break;
  }
}


void InterpretMML (void)
{
  mmlstringpos=1;
  while(!EoF(hMML_File))
    {
      keepgoing=1;
      mmlstringpos=1;
      Clear (Buffer);
      Buffer[0]=0;
      fgets(Buffer,1048576,hMML_File);
      if(Buffer[strlen(Buffer)-1]==10)Buffer[strlen(Buffer)-1]=0;
      RetVal=strlen(Buffer);
      while(mmlstringpos-1<RetVal)
        {
          if(keepgoing==1)
            {
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              selmmlevent();
            }
          if(keepgoing==0)
            {
              mmlstringpos++;
            }
        }
    }
  endtrack();
}


void selmmlevent (void)
{
  while(1)
  {
    if(str_cmp(Buffer2,"A")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==0)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=0)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"B")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==1)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=1)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"C")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==2)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=2)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"D")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==3)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=3)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"E")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==4)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=4)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"F")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==5)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=5)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"G")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==6)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=6)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"H")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==7)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=7)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"I")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==8)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=8)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"J")==0)
      {
        if(mmlstringpos==1)
          {
            if(currentchannel==9)
              {
                keepgoing=1;
                mmlstringpos++;
              }
            if(currentchannel!=9)
              {
                keepgoing=0;
                mmlstringpos++;
              }
          }
        if(mmlstringpos>1)
          {
            mmlstringpos++;
          }
        break;
      }
    if(str_cmp(Buffer2,"[")==0)
      {
        notenum=251;
        notelength=0;
        WriteNote();
        mmlstringpos++;
        break;
      }
    if(str_cmp(Buffer2,"]")==0)
      {
        notenum=250;
        GetThreeDigits2();
        notelength=dummyval2;
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"*")==0)
      {
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval2=VAL(Buffer2);
        if(dummyval2==0)
          {
            if(str_cmp(Buffer2,"0")!=0)
              {
                printf("%s\n","error");
              }
          }
        if(dummyval2>1)
          {
            dummyval2=1;
          }
        mmlstringpos++;
        notenum=245;
        notelength=dummyval2;
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"V")==0)
      {
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval2=VAL(Buffer2);
        if(dummyval2==0)
          {
            if(str_cmp(Buffer2,"0")!=0)
              {
                printf("%s\n","error");
              }
          }
        if(dummyval2>1)
          {
            dummyval2=1;
          }
        mmlstringpos++;
        notenum=243;
        notelength=dummyval2;
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"c")==0)
      {
        notenum=1;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
        if(str_cmp(Buffer2,"-")==0)
          {
            mmlstringpos++;
            if(octnum>0)
              {
                notenum-=1;
              }
          }
        if(str_cmp(Buffer2,"+")==0)
          {
            mmlstringpos++;
            notenum++;
          }
        octmult=octnum*12;
        notenum+=octmult;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"d")==0)
      {
        notenum=3;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
        if(str_cmp(Buffer2,"-")==0)
          {
            mmlstringpos++;
            if(octnum>0)
              {
                notenum-=1;
              }
          }
        if(str_cmp(Buffer2,"+")==0)
          {
            mmlstringpos++;
            notenum++;
          }
        octmult=octnum*12;
        notenum+=octmult;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"e")==0)
      {
        notenum=5;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
        if(str_cmp(Buffer2,"-")==0)
          {
            mmlstringpos++;
            if(octnum>0)
              {
                notenum-=1;
              }
          }
        if(str_cmp(Buffer2,"+")==0)
          {
            mmlstringpos++;
            notenum++;
          }
        octmult=octnum*12;
        notenum+=octmult;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"f")==0)
      {
        notenum=6;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
        if(str_cmp(Buffer2,"-")==0)
          {
            mmlstringpos++;
            if(octnum>0)
              {
                notenum-=1;
              }
          }
        if(str_cmp(Buffer2,"+")==0)
          {
            mmlstringpos++;
            notenum++;
          }
        octmult=octnum*12;
        notenum+=octmult;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"g")==0)
      {
        notenum=8;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
        if(str_cmp(Buffer2,"-")==0)
          {
            mmlstringpos++;
            if(octnum>0)
              {
                notenum-=1;
              }
          }
        if(str_cmp(Buffer2,"+")==0)
          {
            mmlstringpos++;
            notenum++;
          }
        octmult=octnum*12;
        notenum+=octmult;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"a")==0)
      {
        notenum=10;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
        if(str_cmp(Buffer2,"-")==0)
          {
            mmlstringpos++;
            if(octnum>0)
              {
                notenum-=1;
              }
          }
        if(str_cmp(Buffer2,"+")==0)
          {
            mmlstringpos++;
            notenum++;
          }
        octmult=octnum*12;
        notenum+=octmult;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"b")==0)
      {
        notenum=12;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
        if(str_cmp(Buffer2,"-")==0)
          {
            mmlstringpos++;
            if(octnum>0)
              {
                notenum-=1;
              }
          }
        if(str_cmp(Buffer2,"+")==0)
          {
            mmlstringpos++;
            notenum++;
          }
        octmult=octnum*12;
        notenum+=octmult;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"r")==0)
      {
        notenum=0x80;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"&")==0)
      {
        notenum=249;
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        while(1)
        {
          if(str_cmp(Buffer2,"4")==0)
            {
              notelength=24;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=36;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"8")==0)
            {
              notelength=12;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=18;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"2")==0)
            {
              notelength=48;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=72;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"1")==0)
            {
              notelength=96;
              mmlstringpos++;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,".")==0)
                {
                  notelength=144;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=8;
                  mmlstringpos++;
                }
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
              if(str_cmp(Buffer2,"6")==0)
                {
                  notelength=6;
                  mmlstringpos++;
                  Clear (Buffer2);
                  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
                  if(str_cmp(Buffer2,".")==0)
                    {
                      notelength=9;
                      mmlstringpos++;
                    }
                }
              break;
            }
          if(str_cmp(Buffer2,"3")==0)
            {
              notelength=32;
              Clear (Buffer2);
              strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
              if(str_cmp(Buffer2,"2")==0)
                {
                  notelength=3;
                  mmlstringpos++;
                }
              break;
            }
          if(str_cmp(Buffer2,"6")==0)
            {
              notelength=16;
              mmlstringpos++;
              break;
            }
          if(str_cmp(Buffer2,"%")==0)
            {
              GetThreeDigits();
              notelength=dummyval2;
            }
          break;
        }
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"l")==0)
      {
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        if(str_cmp(Buffer2,"4")==0)
          {
            notelength=24;
            defnotelength=24;
            Clear (Buffer2);
            strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
            if(str_cmp(Buffer2,".")==0)
              {
                notelength=36;
                defnotelength=36;
                mmlstringpos++;
              }
          }
        if(str_cmp(Buffer2,"8")==0)
          {
            notelength=12;
            defnotelength=12;
            Clear (Buffer2);
            strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
            if(str_cmp(Buffer2,".")==0)
              {
                notelength=18;
                defnotelength=18;
                mmlstringpos++;
              }
          }
        if(str_cmp(Buffer2,"1")==0)
          {
            notelength=96;
            defnotelength=96;
            Clear (Buffer2);
            strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
            if(str_cmp(Buffer2,".")==0)
              {
                notelength=144;
                defnotelength=144;
                mmlstringpos++;
              }
            Clear (Buffer2);
            strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
            if(str_cmp(Buffer2,"2")==0)
              {
                notelength=8;
                defnotelength=8;
                mmlstringpos++;
              }
            Clear (Buffer2);
            strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
            if(str_cmp(Buffer2,"6")==0)
              {
                defnotelength=6;
                notelength=6;
                mmlstringpos++;
                Clear (Buffer2);
                strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
                if(str_cmp(Buffer2,".")==0)
                  {
                    notelength=9;
                    defnotelength=9;
                    mmlstringpos++;
                  }
              }
          }
        if(str_cmp(Buffer2,"2")==0)
          {
            notelength=48;
            defnotelength=48;
            Clear (Buffer2);
            strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
            if(str_cmp(Buffer2,".")==0)
              {
                notelength=72;
                defnotelength=72;
                mmlstringpos++;
              }
          }
        if(str_cmp(Buffer2,"3")==0)
          {
            Clear (Buffer2);
            strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
            if(str_cmp(Buffer2,"2")==0)
              {
                notelength=3;
                defnotelength=3;
                mmlstringpos++;
              }
          }
        if(str_cmp(Buffer2,"6")==0)
          {
            mmlstringpos++;
            notelength=16;
            defnotelength=16;
          }
        if(str_cmp(Buffer2,"%")==0)
          {
            Clear (Buffer2);
            mmlstringpos++;
            strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
            dummyval2=VAL(Buffer2);
            if(dummyval2==0)
              {
                if(str_cmp(Buffer2,"0")!=0)
                  {
                    printf("%s\n","error");
                    fflush(stdout);
                    //ExitProcess(0);
				exit(0);
                  }
              }
            mmlstringpos++;
            Clear (Buffer2);
            strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
            dummyval3=VAL(Buffer2);
            while(1)
            {
              if(dummyval3==0)
                {
                  while(1)
                  {
                    if(str_cmp(Buffer2,"0")==0)
                      {
                        dummyval2*=10;
                        dummyval2+=dummyval3;
                        mmlstringpos++;
                        Clear (RetStr1);
                        strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
                        dummyval4=VAL(RetStr1);
                        while(1)
                        {
                          if(dummyval4==0)
                            {
                              while(1)
                              {
                                if(str_cmp(RetStr1,"0")==0)
                                  {
                                    dummyval2*=10;
                                    dummyval2+=dummyval4;
                                    mmlstringpos++;
                                  }
                                break;
                              }
                              break;
                            }
                            // case else
                            {
                              dummyval2*=10;
                              dummyval2+=dummyval4;
                              mmlstringpos++;
                            }
                          break;
                        }
                      }
                    break;
                  }
                  break;
                }
                // case else
                {
                  dummyval2*=10;
                  dummyval2+=dummyval3;
                  mmlstringpos++;
                  Clear (RetStr1);
                  strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
                  dummyval4=VAL(RetStr1);
                  while(1)
                  {
                    if(dummyval4==0)
                      {
                        while(1)
                        {
                          if(str_cmp(RetStr1,"0")==0)
                            {
                              dummyval2*=10;
                              dummyval2+=dummyval4;
                              mmlstringpos++;
                            }
                          break;
                        }
                        break;
                      }
                      // case else
                      {
                        dummyval2*=10;
                        dummyval2+=dummyval4;
                        mmlstringpos++;
                      }
                    break;
                  }
                }
              break;
            }
            notelength=dummyval2;
            defnotelength=dummyval2;
          }
        break;
      }
    if(str_cmp(Buffer2,"o")==0)
      {
        Clear (Buffer2);
        mmlstringpos++;
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        octnum=VAL(Buffer2);
        if(octnum>7)
          {
            octnum=7;
          }
        mmlstringpos++;
        break;
      }
    if(str_cmp(Buffer2,"@")==0)
      {
        Clear (Buffer2);
        mmlstringpos++;
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval2=VAL(Buffer2);
        if(dummyval2==0)
          {
            if(str_cmp(Buffer2,"0")!=0)
              {
                printf("%s\n","error");
                fflush(stdout);
                //ExitProcess(0);
			exit(0);
              }
          }
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval3=VAL(Buffer2);
        while(1)
        {
          if(dummyval3==0)
            {
              while(1)
              {
                if(str_cmp(Buffer2,"0")==0)
                  {
                    dummyval2*=10;
                    dummyval2+=dummyval3;
                    mmlstringpos++;
                    Clear (RetStr1);
                    strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
                    dummyval4=VAL(RetStr1);
                    while(1)
                    {
                      if(dummyval4==0)
                        {
                          while(1)
                          {
                            if(str_cmp(RetStr1,"0")==0)
                              {
                                dummyval2*=10;
                                dummyval2+=dummyval4;
                                mmlstringpos++;
                              }
                            break;
                          }
                          break;
                        }
                        // case else
                        {
                          dummyval2*=10;
                          dummyval2+=dummyval4;
                          mmlstringpos++;
                        }
                      break;
                    }
                  }
                break;
              }
              break;
            }
            // case else
            {
              dummyval2*=10;
              dummyval2+=dummyval3;
              mmlstringpos++;
              Clear (RetStr1);
              strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
              dummyval4=VAL(RetStr1);
              while(1)
              {
                if(dummyval4==0)
                  {
                    while(1)
                    {
                      if(str_cmp(RetStr1,"0")==0)
                        {
                          dummyval2*=10;
                          dummyval2+=dummyval4;
                          mmlstringpos++;
                        }
                      break;
                    }
                    break;
                  }
                  // case else
                  {
                    dummyval2*=10;
                    dummyval2+=dummyval4;
                    mmlstringpos++;
                  }
                break;
              }
            }
          break;
        }
        neirobangou=dummyval2;
        Clear (RetStr2);
        strcpy(RetStr2,rtrim(MKI(255),32));
        PUT(hNewMMD,RetStr2,1);
        Clear (RetStr2);
        strcpy(RetStr2,rtrim(MKI(neirobangou),32));
        PUT(hNewMMD,RetStr2,1);
        AdvanceFilePos(2);
        break;
      }
    if(str_cmp(Buffer2,"#")==0)
      {
        GetThreeDigits();
        notenum=253;
        notelength=dummyval2;
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"p")==0)
      {
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval2=VAL(Buffer2);
        if(dummyval2==0)
          {
            if(str_cmp(Buffer2,"0")!=0)
              {
                printf("%s\n","error");
                fflush(stdout);
                //ExitProcess(0);
			exit(0);
              }
          }
        if(dummyval2>3)
          {
            dummyval2=3;
          }
        mmlstringpos++;
        notenum=248;
        notelength=dummyval2*64;
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"t")==0)
      {
        Clear (Buffer2);
        mmlstringpos++;
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval2=VAL(Buffer2);
        if(dummyval2==0)
          {
            if(str_cmp(Buffer2,"0")!=0)
              {
                printf("%s\n","error");
                fflush(stdout);
                //ExitProcess(0);
			exit(0);
              }
          }
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval3=VAL(Buffer2);
        while(1)
        {
          if(dummyval3==0)
            {
              while(1)
              {
                if(str_cmp(Buffer2,"0")==0)
                  {
                    dummyval2*=10;
                    dummyval2+=dummyval3;
                    mmlstringpos++;
                    Clear (RetStr1);
                    strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
                    dummyval4=VAL(RetStr1);
                    while(1)
                    {
                      if(dummyval4==0)
                        {
                          while(1)
                          {
                            if(str_cmp(RetStr1,"0")==0)
                              {
                                dummyval2*=10;
                                dummyval2+=dummyval4;
                                mmlstringpos++;
                              }
                            break;
                          }
                          break;
                        }
                        // case else
                        {
                          dummyval2*=10;
                          dummyval2+=dummyval4;
                          mmlstringpos++;
                        }
                      break;
                    }
                  }
                break;
              }
              break;
            }
            // case else
            {
              dummyval2*=10;
              dummyval2+=dummyval3;
              mmlstringpos++;
              Clear (RetStr1);
              strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
              dummyval4=VAL(RetStr1);
              while(1)
              {
                if(dummyval4==0)
                  {
                    while(1)
                    {
                      if(str_cmp(RetStr1,"0")==0)
                        {
                          dummyval2*=10;
                          dummyval2+=dummyval4;
                          mmlstringpos++;
                        }
                      break;
                    }
                    break;
                  }
                  // case else
                  {
                    dummyval2*=10;
                    dummyval2+=dummyval4;
                    mmlstringpos++;
                  }
                break;
              }
            }
          break;
        }
        timerbsetting2=dummyval2;
        Clear (RetStr2);
        strcpy(RetStr2,rtrim(MKI(252),32));
        PUT(hNewMMD,RetStr2,1);
        Clear (RetStr2);
        strcpy(RetStr2,rtrim(MKI(timerbsetting2),32));
        if(timerbsetting2==32)
          {
            strcpy(RetStr2," ");
          }
        PUT(hNewMMD,RetStr2,1);
        AdvanceFilePos(2);
        break;
      }
    if(str_cmp(Buffer2,">")==0)
      {
        if(octnum<7)
          {
            octnum++;
          }
        mmlstringpos++;
        break;
      }
    if(str_cmp(Buffer2,"<")==0)
      {
        if(octnum>0)
          {
            octnum--;
          }
        mmlstringpos++;
        break;
      }
    if(str_cmp(Buffer2,"v")==0)
      {
        Clear (Buffer2);
        mmlstringpos++;
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval2=VAL(Buffer2);
        if(dummyval2==0)
          {
            if(str_cmp(Buffer2,"0")!=0)
              {
                printf("%s\n","error");
                fflush(stdout);
                //ExitProcess(0);
			exit(0);
              }
          }
        mmlstringpos++;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
        dummyval3=VAL(Buffer2);
        if(dummyval3==0)
          {
            while(1)
            {
              if(str_cmp(Buffer2,"0")==0)
                {
                  dummyval2*=10;
                  dummyval2+=dummyval3;
                  mmlstringpos++;
                }
              break;
            }
          }
        if(dummyval3>0)
          {
            dummyval2*=10;
            dummyval2+=dummyval3;
            mmlstringpos++;
          }
        if(dummyval2>15)
          {
            dummyval2=15;
          }
        while(1)
        {
          if(dummyval2==0)
            {
              notelength=36;
              break;
            }
          if(dummyval2==1)
            {
              notelength=34;
              break;
            }
          if(dummyval2==2)
            {
              notelength=32;
              break;
            }
          if(dummyval2==3)
            {
              notelength=30;
              break;
            }
          if(dummyval2==4)
            {
              notelength=28;
              break;
            }
          if(dummyval2==5)
            {
              notelength=26;
              break;
            }
          if(dummyval2==6)
            {
              notelength=24;
              break;
            }
          if(dummyval2==7)
            {
              notelength=22;
              break;
            }
          if(dummyval2==8)
            {
              notelength=20;
              break;
            }
          if(dummyval2==9)
            {
              notelength=18;
              break;
            }
          if(dummyval2==10)
            {
              notelength=16;
              break;
            }
          if(dummyval2==11)
            {
              notelength=14;
              break;
            }
          if(dummyval2==12)
            {
              notelength=12;
              break;
            }
          if(dummyval2==13)
            {
              notelength=10;
              break;
            }
          if(dummyval2==14)
            {
              notelength=8;
              break;
            }
          if(dummyval2==15)
            {
              notelength=6;
            }
          break;
        }
        notenum=247;
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"!")==0)
      {
        notenum=246;
        Clear (Buffer2);
        strcpy(Buffer2,mid(Buffer,mmlstringpos+1,1));
        if(str_cmp(Buffer2,"-")==0)
          {
            notenum=242;
            mmlstringpos++;
          }
        GetTwoDigits();
        pitchbend=dummyval2;
        notelength=pitchbend;
        WriteNote();
        break;
      }
    if(str_cmp(Buffer2,"L")==0)
      {
        notenum=244;
        notelength=0;
        WriteNote();
        mmlstringpos++;
        break;
      }
      // case else
      {
        if(mmlstringpos==1)
          {
            keepgoing=0;
          }
        mmlstringpos++;
      }
    break;
  }
}


void writestartpos (void)
{
  dummyval1=0;
  dummyval2=0;
  filepos=0;
fseek(hNewMMD,0,0);
  while(PartAStart>255)
    {
      PartAStart-=256;
      dummyval1++;
    }
  dummyval2=PartAStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,2,0);
  while(PartBStart>255)
    {
      PartBStart-=256;
      dummyval1++;
    }
  dummyval2=PartBStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,4,0);
  while(PartCStart>255)
    {
      PartCStart-=256;
      dummyval1++;
    }
  dummyval2=PartCStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,6,0);
  while(PartDStart>255)
    {
      PartDStart-=256;
      dummyval1++;
    }
  dummyval2=PartDStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,8,0);
  while(PartEStart>255)
    {
      PartEStart-=256;
      dummyval1++;
    }
  dummyval2=PartEStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,10,0);
  while(PartFStart>255)
    {
      PartFStart-=256;
      dummyval1++;
    }
  dummyval2=PartFStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  if(dummyval1==32)
    {
      strcpy(Buffer," ");
    }
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval2==32)
    {
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,12,0);
  while(PartGStart>255)
    {
      PartGStart-=256;
      dummyval1++;
    }
  dummyval2=PartGStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,14,0);
  while(PartHStart>255)
    {
      PartHStart-=256;
      dummyval1++;
    }
  dummyval2=PartHStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,16,0);
  while(PartIStart>255)
    {
      PartIStart-=256;
      dummyval1++;
    }
  dummyval2=PartIStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,18,0);
  while(PartJStart>255)
    {
      PartJStart-=256;
      dummyval1++;
    }
  dummyval2=PartJStart;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=4;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
  dummyval1=0;
  dummyval2=0;
fseek(hNewMMD,22,0);
  while(userneiropos>255)
    {
      userneiropos-=256;
      dummyval1++;
    }
  dummyval2=userneiropos;
  Clear (Buffer);
  strcpy(Buffer,rtrim(MKI(dummyval1),32));
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(dummyval2),32));
  if(dummyval1==32)
    {
      Clear (Buffer);
      strcpy(Buffer," ");
    }
  if(dummyval2==32)
    {
      Clear (Buffer2);
      strcpy(Buffer2," ");
    }
  filepos+=2;
  PUT(hNewMMD,Buffer,1);
  PUT(hNewMMD,Buffer2,1);
}


void WriteNote (void)
{
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(notenum),32));
  if(notenum==32)
    {
      strcpy(Buffer2," ");
    }
  PUT(hNewMMD,Buffer2,1);
  Clear (Buffer2);
  strcpy(Buffer2,rtrim(MKI(notelength),32));
  if(notelength==32)
    {
      strcpy(Buffer2," ");
    }
  PUT(hNewMMD,Buffer2,1);
  AdvanceFilePos(2);
  notelength=defnotelength;
}


void AdvanceFilePos (int amount)
{
  filepos+=amount;
fseek(hNewMMD,filepos,0);
}


void GetThreeDigits (void)
{
  Clear (Buffer2);
  mmlstringpos++;
  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
  dummyval2=VAL(Buffer2);
  if(dummyval2==0)
    {
      if(str_cmp(Buffer2,"0")!=0)
        {
          printf("%s\n","error");
          fflush(stdout);
          //ExitProcess(0);
		exit(0);
        }
    }
  mmlstringpos++;
  Clear (Buffer2);
  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
  dummyval3=VAL(Buffer2);
  while(1)
  {
    if(dummyval3==0)
      {
        while(1)
        {
          if(str_cmp(Buffer2,"0")==0)
            {
              dummyval2*=10;
              dummyval2+=dummyval3;
              mmlstringpos++;
              Clear (RetStr1);
              strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
              dummyval4=VAL(RetStr1);
              while(1)
              {
                if(dummyval4==0)
                  {
                    while(1)
                    {
                      if(str_cmp(RetStr1,"0")==0)
                        {
                          dummyval2*=10;
                          dummyval2+=dummyval4;
                          mmlstringpos++;
                        }
                      break;
                    }
                    break;
                  }
                  // case else
                  {
                    dummyval2*=10;
                    dummyval2+=dummyval4;
                    mmlstringpos++;
                  }
                break;
              }
            }
          break;
        }
        break;
      }
      // case else
      {
        dummyval2*=10;
        dummyval2+=dummyval3;
        mmlstringpos++;
        Clear (RetStr1);
        strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
        dummyval4=VAL(RetStr1);
        while(1)
        {
          if(dummyval4==0)
            {
              while(1)
              {
                if(str_cmp(RetStr1,"0")==0)
                  {
                    dummyval2*=10;
                    dummyval2+=dummyval4;
                    mmlstringpos++;
                  }
                break;
              }
              break;
            }
            // case else
            {
              dummyval2*=10;
              dummyval2+=dummyval4;
              mmlstringpos++;
            }
          break;
        }
      }
    break;
  }
}


void GetThreeDigits2 (void)
{
  stopsub=0;
  Clear (Buffer2);
  mmlstringpos++;
  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
  dummyval2=VAL(Buffer2);
  if(dummyval2==0)
    {
      if(str_cmp(Buffer2,"0")!=0)
        {
          dummyval2=0;
          stopsub=1;
        }
    }
  if(stopsub==0)
    {
      mmlstringpos++;
      Clear (Buffer2);
      strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
      dummyval3=VAL(Buffer2);
      while(1)
      {
        if(dummyval3==0)
          {
            while(1)
            {
              if(str_cmp(Buffer2,"0")==0)
                {
                  dummyval2*=10;
                  dummyval2+=dummyval3;
                  mmlstringpos++;
                  Clear (RetStr1);
                  strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
                  dummyval4=VAL(RetStr1);
                  while(1)
                  {
                    if(dummyval4==0)
                      {
                        while(1)
                        {
                          if(str_cmp(RetStr1,"0")==0)
                            {
                              dummyval2*=10;
                              dummyval2+=dummyval4;
                              mmlstringpos++;
                            }
                          break;
                        }
                        break;
                      }
                      // case else
                      {
                        dummyval2*=10;
                        dummyval2+=dummyval4;
                        mmlstringpos++;
                      }
                    break;
                  }
                }
              break;
            }
            break;
          }
          // case else
          {
            dummyval2*=10;
            dummyval2+=dummyval3;
            mmlstringpos++;
            Clear (RetStr1);
            strcpy(RetStr1,mid(Buffer,mmlstringpos,1));
            dummyval4=VAL(RetStr1);
            while(1)
            {
              if(dummyval4==0)
                {
                  while(1)
                  {
                    if(str_cmp(RetStr1,"0")==0)
                      {
                        dummyval2*=10;
                        dummyval2+=dummyval4;
                        mmlstringpos++;
                      }
                    break;
                  }
                  break;
                }
                // case else
                {
                  dummyval2*=10;
                  dummyval2+=dummyval4;
                  mmlstringpos++;
                }
              break;
            }
          }
        break;
      }
    }
}


void GetTwoDigits (void)
{
  Clear (Buffer2);
  mmlstringpos++;
  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
  dummyval2=VAL(Buffer2);
  if(dummyval2==0)
    {
      if(str_cmp(Buffer2,"0")!=0)
        {
          printf("%s\n","error");
          fflush(stdout);
          //ExitProcess(0);
		exit(0);
        }
    }
  mmlstringpos++;
  Clear (Buffer2);
  strcpy(Buffer2,mid(Buffer,mmlstringpos,1));
  dummyval3=VAL(Buffer2);
  while(1)
  {
    if(dummyval3==0)
      {
        if(str_cmp(Buffer2,"0")==0)
          {
            dummyval2*=10;
            dummyval2+=dummyval3;
            mmlstringpos++;
          }
        break;
      }
      // case else
      {
        dummyval2*=10;
        dummyval2+=dummyval3;
        mmlstringpos++;
      }
    break;
  }
}


